Index: gs3-extensions/html-to-expeditee/trunk/src/perllib/CssStyleToExpAttr.pm
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/perllib/CssStyleToExpAttr.pm	(revision 26726)
+++ gs3-extensions/html-to-expeditee/trunk/src/perllib/CssStyleToExpAttr.pm	(revision 26727)
@@ -55,4 +55,5 @@
   "tahoma"    		=> "sans-serif",
   "geneva"    		=> "sans-serif",
+  "georgia"			=> "serif",
   "times"    		=> "serif",
   "times new roman"    	=> "serif",
@@ -351,7 +352,14 @@
     my $exp_font_size = undef;
 
-    if ($css_font_size =~ m/^(\d+(?:\.\d*))px$/) {
-	$exp_font_size = int($1);
-    }
+	
+    #if ($css_font_size =~ m/^(\d+(?:\.\d*))px$/) {
+	#	$exp_font_size = int($1);
+    #}
+	
+	$css_font_size =~ s/[^0-9]//g;
+	
+	if(defined $css_font_size){
+		$exp_font_size = $css_font_size;
+	}
 
     return $exp_font_size;
@@ -384,5 +392,35 @@
     return $exp_color;
 }
+
+sub convert_font_family
+{
+    my ($css_font_family) = @_;
+		
+	print STDERR "*** PASSING PARAMETER css font family: ".$css_font_family."\n";
+	
+	my $exp_font_family;
+	
+	#use $font_specific_family_lookup and $font_generic_family_lookup
+	#to find the appropriate font family tag to output to expeditee.
+	if(defined $font_specific_family_lookup->{lc($css_font_family)}){
+		$exp_font_family = $css_font_family."_";
+	}
+	
+	print STDERR "**** TESTING TESTING ".$font_specific_family_lookup->{"georgia"}."\n";
+	print STDERR "**** TESTING TESTING ".$font_specific_family_lookup->{lc($css_font_family)}."\n";
+	print STDERR "**** TESTING TESTING ".$font_specific_family_lookup->{$css_font_family}."\n";
+	print STDERR "In CssStyleToExpAttr: font family attribute: $exp_font_family ******* \n";
+	
+	return $exp_font_family;
+}
+
+sub convert_font_style
+{
+	my ($css_font_style) = @_;
+
+	my $exp_font_style;
+	
+	return $exp_font_style;
+}
     
 1;
-    
Index: gs3-extensions/html-to-expeditee/trunk/src/perllib/ExpediteeFrameIO.pm
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/perllib/ExpediteeFrameIO.pm	(revision 26726)
+++ gs3-extensions/html-to-expeditee/trunk/src/perllib/ExpediteeFrameIO.pm	(revision 26727)
@@ -77,5 +77,5 @@
     my $exp_font_family = "s"; # t
     my $exp_font_face = "r";
-    my $exp_font_size = "14";
+    my $exp_font_size = "18";
 
 #    if (defined $css_attr->{'font-family'}) {
@@ -84,23 +84,51 @@
 
     if (defined $css_attr->{'font-size'}) {
-	my $css_font_size = $css_attr->{'font-size'};
-	$exp_font_size = CssStyleToExpAttr::convert_font_size($css_font_size);
-    }
-
+		
+		my $css_font_size = $css_attr->{'font-size'};
+		$exp_font_size = CssStyleToExpAttr::convert_font_size($css_font_size);
+		
+		print STDERR "CSS Font Size is defined: ".$css_font_size."\n";
+		print STDERR "Equivalent expeditee font size: ".$exp_font_size."\n";
+    }
+	
+	if(defined $css_attr->{'font-family'}){
+	    my $obtain_font_family = $css_attr->{'font-family'};
+		print STDERR "Font family attribute found: ".$obtain_font_family."\n";
+		my $new_exp_font_family = CssStyleToExpAttr::convert_font_family($obtain_font_family);	
+
+		if(defined $new_exp_font_family){
+			$exp_font_family = $new_exp_font_family;
+		}
+	}
+	
+	if(defined $css_attr->{'font-face'}){
+		print STDERR "Font face attribute found: ".$css_attr->{'font-face'}."\n";
+		
+		#now need to call a method from CssStyleToExpAttr.pm to extract the matching
+		#font symbol
+		#s - 
+	}
+	
+	if(defined $css_attr->{'font-weight'}){
+		print STDERR "Font weight attribute found: ".$css_attr->{'font-weight'}."\n";
+	}
+	
 #    if (defined $css_attr->{'font-face'}) {
 #	$font = conver_font_face($css_attr->{'font-face'});
 #    }
 
-#    $exp_attr->{'f'} = $exp_font_family.$exp_font_face.$exp_font_size;
-
+	 $exp_attr->{'f'} = $exp_font_family.$exp_font_face.$exp_font_size;
+	 
+	 print STDERR "**** final converted Expeditee font: ".$exp_attr->{'f'};
+	 
     # background color
 
 
     if (defined $css_attr->{'background-color'}) {
-	my $css_color = $css_attr->{'background-color'};
-
-	my $exp_color = CssStyleToExpAttr::convert_color($css_color);
-
-	$exp_attr->{'e'} = $exp_color;
+		my $css_color = $css_attr->{'background-color'};
+
+		my $exp_color = CssStyleToExpAttr::convert_color($css_color);
+
+		$exp_attr->{'e'} = $exp_color;
     }
 
@@ -550,4 +578,9 @@
 	    }
 	}
+	
+	#don't want to add font information to non-text items!
+	my $deleted = delete $attr->{'f'};
+	
+	print STDERR "**** DELETED: $deleted \n";
 
 	$self->addRect($xl,$yt,$xr,$yb,$attr);
@@ -578,4 +611,5 @@
     }
     elsif ($type eq "text") {
+	
 	my $text = $html_node->{'text'};
 
@@ -584,6 +618,13 @@
 	my $w = $html_node->{'xr'} - $x +1;
 
+	print STDERR "**** CHECKING STYLE NODE: ".$html_node->{'style'}."\n";
 	my $attr = convertStyleToAttr($html_node->{'style'});
-
+	
+	#DEBUGGING
+	if(defined $attr->{'f'}){
+		print STDERR "***** Checking text attributes:".$attr->{'f'}."\n";
+		print STDERR "****************************************\n";
+	}
+	
 	# fudge factor for now (based on default font size used)
 	$y += 16; # y-value of text item in Expeditee is it's base line