Index: gs3-extensions/html-to-expeditee/trunk/src/perllib/CssStyleToExpAttr.pm
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/perllib/CssStyleToExpAttr.pm	(revision 26727)
+++ gs3-extensions/html-to-expeditee/trunk/src/perllib/CssStyleToExpAttr.pm	(revision 26728)
@@ -353,15 +353,23 @@
 
 	
-    #if ($css_font_size =~ m/^(\d+(?:\.\d*))px$/) {
-	#	$exp_font_size = int($1);
-    #}
-	
-	$css_font_size =~ s/[^0-9]//g;
-	
-	if(defined $css_font_size){
-		$exp_font_size = $css_font_size;
+    if ($css_font_size =~ m/^(\d+(?:\.\d*))px$/) {
+		$exp_font_size = int($1);
+    }
+	
+    return $exp_font_size;
+}
+
+sub convert_font_face
+{
+	my ($css_font_face) = @_;
+	my $exp_font_face = undef;
+	
+	if(lc($css_font_face) eq "bold"){
+			$exp_font_face = "b";
+	}else{		#for now - also need to take into account italic and italic bold.
+		$exp_font_face = "r";
 	}
 
-    return $exp_font_size;
+	return $exp_font_face;
 }
 
@@ -405,10 +413,15 @@
 	if(defined $font_specific_family_lookup->{lc($css_font_family)}){
 		$exp_font_family = $css_font_family."_";
+	}else{
+	
+		#to account for instances where a list of fonts is stored as the font family, e.g. "Arial,Segoe...Sans-Serif".
+		#just extract the first font name from this list.
+		my @font_family_vals = split(',',$css_font_family);
+		
+		if(scalar(@font_family_vals) > 0){
+			$exp_font_family = $font_family_vals[0]."_";
+		}
+	
 	}
-	
-	print STDERR "**** TESTING TESTING ".$font_specific_family_lookup->{"georgia"}."\n";
-	print STDERR "**** TESTING TESTING ".$font_specific_family_lookup->{lc($css_font_family)}."\n";
-	print STDERR "**** TESTING TESTING ".$font_specific_family_lookup->{$css_font_family}."\n";
-	print STDERR "In CssStyleToExpAttr: font family attribute: $exp_font_family ******* \n";
 	
 	return $exp_font_family;
Index: gs3-extensions/html-to-expeditee/trunk/src/perllib/ExpediteeFrameIO.pm
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/perllib/ExpediteeFrameIO.pm	(revision 26727)
+++ gs3-extensions/html-to-expeditee/trunk/src/perllib/ExpediteeFrameIO.pm	(revision 26728)
@@ -87,12 +87,9 @@
 		my $css_font_size = $css_attr->{'font-size'};
 		$exp_font_size = CssStyleToExpAttr::convert_font_size($css_font_size);
-		
-		print STDERR "CSS Font Size is defined: ".$css_font_size."\n";
-		print STDERR "Equivalent expeditee font size: ".$exp_font_size."\n";
+
     }
 	
 	if(defined $css_attr->{'font-family'}){
 	    my $obtain_font_family = $css_attr->{'font-family'};
-		print STDERR "Font family attribute found: ".$obtain_font_family."\n";
 		my $new_exp_font_family = CssStyleToExpAttr::convert_font_family($obtain_font_family);	
 
@@ -102,23 +99,17 @@
 	}
 	
-	if(defined $css_attr->{'font-face'}){
-		print STDERR "Font face attribute found: ".$css_attr->{'font-face'}."\n";
-		
-		#now need to call a method from CssStyleToExpAttr.pm to extract the matching
-		#font symbol
-		#s - 
+	if(defined $css_attr->{'font-style'}){
+		print STDERR "Font style attribute found: ".$css_attr->{'font-style'}."\n";
 	}
 	
 	if(defined $css_attr->{'font-weight'}){
 		print STDERR "Font weight attribute found: ".$css_attr->{'font-weight'}."\n";
+		
+		my $css_font_face = $css_attr->{'font-weight'};
+		$exp_font_face = CssStyleToExpAttr::convert_font_face($css_font_face);
 	}
 	
-#    if (defined $css_attr->{'font-face'}) {
-#	$font = conver_font_face($css_attr->{'font-face'});
-#    }
-
 	 $exp_attr->{'f'} = $exp_font_family.$exp_font_face.$exp_font_size;
-	 
-	 print STDERR "**** final converted Expeditee font: ".$exp_attr->{'f'};
+	 print STDERR "exp attribute obtained: ".$exp_attr->{'f'}." ****\n";
 	 
     # background color
@@ -581,6 +572,4 @@
 	#don't want to add font information to non-text items!
 	my $deleted = delete $attr->{'f'};
-	
-	print STDERR "**** DELETED: $deleted \n";
 
 	$self->addRect($xl,$yt,$xr,$yb,$attr);
@@ -617,13 +606,6 @@
 	my $y = $html_node->{'yt'};
 	my $w = $html_node->{'xr'} - $x +1;
-
-	print STDERR "**** CHECKING STYLE NODE: ".$html_node->{'style'}."\n";
+	
 	my $attr = convertStyleToAttr($html_node->{'style'});
-	
-	#DEBUGGING
-	if(defined $attr->{'f'}){
-		print STDERR "***** Checking text attributes:".$attr->{'f'}."\n";
-		print STDERR "****************************************\n";
-	}
 	
 	# fudge factor for now (based on default font size used)
Index: gs3-extensions/html-to-expeditee/trunk/src/src/cgi-bin/html-to-expeditee.pl.in
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/src/cgi-bin/html-to-expeditee.pl.in	(revision 26727)
+++ gs3-extensions/html-to-expeditee/trunk/src/src/cgi-bin/html-to-expeditee.pl.in	(revision 26728)
@@ -256,5 +256,4 @@
 	      var expFrame = JSON.stringify(expFrameTree);
 		  
-		  console.log("******");
 		  console.log(expFrame);
 		  
Index: gs3-extensions/html-to-expeditee/trunk/src/src/js/html-to-expeditee.js
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/src/js/html-to-expeditee.js	(revision 26727)
+++ gs3-extensions/html-to-expeditee/trunk/src/src/js/html-to-expeditee.js	(revision 26728)
@@ -5,4 +5,5 @@
 var font_size;
 var font_color;
+var font_weight;
 
 Element.prototype.getElementWidth = function() {
@@ -159,4 +160,6 @@
 			var new_font_color = getStyle(parent,"color");
 			
+			var new_font_weight = getStyle(parent,"font-weight");
+			
 			if(new_font_family !== undefined && new_font_family !== null)
 				font_family = new_font_family;
@@ -167,4 +170,7 @@
 			if(new_font_color !== undefined && new_font_color !== null)
 				font_color = new_font_color;
+				
+			if(new_font_weight !== undefined && new_font_weight !== null)
+				font_weight = new_font_weight;
 			
 			var data = parent.attributes["data"];
@@ -173,12 +179,18 @@
 				jsonNode.data = data.value;
 			}
-			jsonNode.style = style;
-	    }
-	}
-	
+			
 			var style = {};	
 			style["font-family"]      = font_family;
 			style["font-size"]        = font_size;
 			style["color"] 			  = font_color;
+			style["font-weight"]	  = font_weight;
+			
+			//TODO: if parent node is a <b> element, then set style["font-weight"] to be "bold".
+			
+			jsonNode.style = style;
+	    }
+	}
+	
+			
 	
     }