Index: /main/trunk/greenstone2/common-src/src/gdbmedit/db2txt/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/src/gdbmedit/db2txt/Makefile.in	(revision 26820)
+++ /main/trunk/greenstone2/common-src/src/gdbmedit/db2txt/Makefile.in	(revision 26821)
@@ -35,4 +35,6 @@
 GSDLOS = @gsdlos@
 INCLUDES = -I$(COMMON_PACKAGES_DIR)/gdbm/include -I$(COMMON_DIR)/src/lib
+
+STRIP   = @STRIP@
 INSTALL = @INSTALL@
 LDFLAGS = @LDFLAGS@ @ARCH_DEP_FLAGS@
@@ -70,5 +72,6 @@
 install: $(EXECUTABLE)
 	$(INSTALL) -d $(GSDL_DIR)/bin/$(GSDLOS)
-	$(INSTALL) -m 755 -s $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
+	$(STRIP) $(EXECUTABLE)
+	$(INSTALL) -m 755 $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
 
 clean:
Index: /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmdel/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmdel/Makefile.in	(revision 26820)
+++ /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmdel/Makefile.in	(revision 26821)
@@ -35,4 +35,6 @@
 GSDLOS = @gsdlos@
 INCLUDES = -I$(COMMON_PACKAGES_DIR)/gdbm/include -I$(COMMON_DIR)/src/lib
+
+STRIP   = @STRIP@
 INSTALL = @INSTALL@
 LDFLAGS = @LDFLAGS@ @ARCH_DEP_FLAGS@
@@ -70,5 +72,6 @@
 install: $(EXECUTABLE)
 	$(INSTALL) -d $(GSDL_DIR)/bin/$(GSDLOS)
-	$(INSTALL) -m 755 -s $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
+	$(STRIP) $(EXECUTABLE)
+	$(INSTALL) -m 755 $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
 
 clean:
Index: /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmget/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmget/Makefile.in	(revision 26820)
+++ /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmget/Makefile.in	(revision 26821)
@@ -35,4 +35,5 @@
 GSDLOS = @gsdlos@
 INCLUDES = -I$(COMMON_PACKAGES_DIR)/gdbm/include -I$(COMMON_DIR)/src/lib
+STRIP   = @STRIP@
 INSTALL = @INSTALL@
 LDFLAGS = @LDFLAGS@ @ARCH_DEP_FLAGS@
@@ -70,5 +71,6 @@
 install: $(EXECUTABLE)
 	$(INSTALL) -d $(GSDL_DIR)/bin/$(GSDLOS)
-	$(INSTALL) -m 755 -s $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
+	$(STRIP) $(EXECUTABLE)
+	$(INSTALL) -m 755 $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
 
 clean:
Index: /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmkeys/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmkeys/Makefile.in	(revision 26820)
+++ /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmkeys/Makefile.in	(revision 26821)
@@ -35,4 +35,5 @@
 GSDLOS = @gsdlos@
 INCLUDES = -I$(COMMON_PACKAGES_DIR)/gdbm/include -I$(COMMON_DIR)/src/lib
+STRIP   = @STRIP@
 INSTALL = @INSTALL@
 LDFLAGS = @LDFLAGS@ @ARCH_DEP_FLAGS@
@@ -70,5 +71,6 @@
 install: $(EXECUTABLE)
 	$(INSTALL) -d $(GSDL_DIR)/bin/$(GSDLOS)
-	$(INSTALL) -m 755 -s $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
+	$(STRIP) $(EXECUTABLE)
+	$(INSTALL) -m 755 $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
 
 clean:
Index: /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmset/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmset/Makefile.in	(revision 26820)
+++ /main/trunk/greenstone2/common-src/src/gdbmedit/gdbmset/Makefile.in	(revision 26821)
@@ -35,4 +35,5 @@
 GSDLOS = @gsdlos@
 INCLUDES = -I$(COMMON_PACKAGES_DIR)/gdbm/include -I$(COMMON_DIR)/src/lib
+STRIP   = @STRIP@
 INSTALL = @INSTALL@
 LDFLAGS = @LDFLAGS@ @ARCH_DEP_FLAGS@
@@ -70,5 +71,6 @@
 install: $(EXECUTABLE)
 	$(INSTALL) -d $(GSDL_DIR)/bin/$(GSDLOS)
-	$(INSTALL) -m 755 -s $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
+	$(STRIP) $(EXECUTABLE)
+	$(INSTALL) -m 755 $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
 
 clean:
Index: /main/trunk/greenstone2/common-src/src/gdbmedit/txt2db/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/src/gdbmedit/txt2db/Makefile.in	(revision 26820)
+++ /main/trunk/greenstone2/common-src/src/gdbmedit/txt2db/Makefile.in	(revision 26821)
@@ -35,4 +35,6 @@
 GSDLOS = @gsdlos@
 INCLUDES = -I$(COMMON_PACKAGES_DIR)/gdbm/include -I$(COMMON_DIR)/src/lib
+
+STRIP   = @STRIP@
 INSTALL = @INSTALL@
 LDFLAGS = @LDFLAGS@ @ARCH_DEP_FLAGS@
@@ -74,5 +76,6 @@
 install: $(EXECUTABLE)
 	$(INSTALL) -d $(GSDL_DIR)/bin/$(GSDLOS)
-	$(INSTALL) -m 755 -s $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
+	$(STRIP) $(EXECUTABLE)
+	$(INSTALL) -m 755 $(EXECUTABLE) $(GSDL_DIR)/bin/$(GSDLOS)
 
 clean: